Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_index.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_index.html	(revision 741)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_index.html	(revision 1065)
@@ -13,5 +13,5 @@
 </HEAD>
 <BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(GTPLayout, 900, 658))" STYLE="background-image: none;" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
-    <TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=672 NOF=LY>
+    <TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=681 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
             <TD>
@@ -41,12 +41,12 @@
                     </TR>
                 </TABLE>
-                <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=628 NOF=LY>
+                <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=637 NOF=LY>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=45 HEIGHT=11><IMG SRC="./assets/images/autogen/clearpixel.gif" WIDTH=45 HEIGHT=1 BORDER=0 ALT=""></TD>
+                        <TD WIDTH=33 HEIGHT=11><IMG SRC="./assets/images/autogen/clearpixel.gif" WIDTH=33 HEIGHT=1 BORDER=0 ALT=""></TD>
                         <TD></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
                         <TD HEIGHT=39></TD>
-                        <TD WIDTH=583><IMG ID="Bild445" HEIGHT=39 WIDTH=583 SRC="./assets/images/autogen/a_banner3_transparent_grey254_400px02.gif" BORDER=0 ALT="Advanced Tools for Developing Leading Edge 3D Applications/Games" TITLE="Advanced Tools for Developing Leading Edge 3D Applications/Games"></TD>
+                        <TD WIDTH=604><IMG ID="Bild445" HEIGHT=39 WIDTH=604 SRC="./assets/images/autogen/a_banner3_transparent_grey254_400px02.gif" BORDER=0 ALT="Advanced Tools for Developing Leading Edge 3D Applications/Games" TITLE="Advanced Tools for Developing Leading Edge 3D Applications/Games"></TD>
                     </TR>
                 </TABLE>
Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/header_videos___images.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/header_videos___images.html	(revision 741)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/header_videos___images.html	(revision 1065)
@@ -12,5 +12,5 @@
 </STYLE>
 </HEAD>
-<BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(VideosImagesLayout, 727, 1910))" STYLE="background-color: rgb(255,255,255); background-image: url('../assets/images/upper2.png');" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
+<BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(VideosImagesLayout, 727, 2254))" STYLE="background-color: rgb(255,255,255); background-image: url('../assets/images/upper2.png');" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
     <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=752 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/left_videos___images.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/left_videos___images.html	(revision 741)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/left_videos___images.html	(revision 1065)
@@ -25,5 +25,5 @@
 </NOLAYER>
 </HEAD>
-<BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(VideosImagesLayout, 727, 1910))" STYLE="background-image: url('../assets/images/menu_lateral.JPG');" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
+<BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(VideosImagesLayout, 727, 2254))" STYLE="background-image: url('../assets/images/menu_lateral.JPG');" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
     <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=171 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_videos___images.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_videos___images.html	(revision 741)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Preview/body_videos___images.html	(revision 1065)
@@ -12,5 +12,5 @@
 </STYLE>
 </HEAD>
-<BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(VideosImagesLayout, 727, 1910))" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
+<BODY NOF="(MB=(DefaultMasterBorder, 121, 49, 171, 0), L=(VideosImagesLayout, 727, 2254))" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
     <TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=654 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
@@ -18,5 +18,5 @@
                 <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=44 NOF=LY>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=19 HEIGHT=1910><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=19 HEIGHT=1 BORDER=0 ALT=""></TD>
+                        <TD WIDTH=19 HEIGHT=2254><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=19 HEIGHT=1 BORDER=0 ALT=""></TD>
                         <TD WIDTH=25><IMG SRC="../assets/images/autogen/clearpixel.gif" WIDTH=25 HEIGHT=1 BORDER=0 ALT=""></TD>
                     </TR>
@@ -53,27 +53,41 @@
                             <TABLE ID="Tabelle3" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%">
                                 <TR>
-                                    <TD COLSPAN=2 STYLE="background-color: rgb(166,179,224);">
-                                        <P STYLE="text-align: center;"><B>September 2005</B></P>
-                                    </TD>
-                                </TR>
-                                <TR>
                                     <TD WIDTH=102>
+                                        <P>&nbsp;</P>
+                                    </TD>
+                                    <TD>
+                                        <P>&nbsp;</P>
+                                    </TD>
+                                </TR>
+                                <TR>
+                                    <TD>
+                                        <P><A HREF="http://www.gametools.org/videos/trees.avi"><IMG ID="Picture456" HEIGHT=100 WIDTH=100 SRC="../assets/images/trees.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="trees" TITLE="trees"></A></P>
+                                    </TD>
+                                    <TD VALIGN=TOP>
+                                        <P><SPAN STYLE="font-size: 8pt;">Level of Detail for Trees, running at a constant high framrate (thats a lot of leaves in there)</SPAN></P>
+                                    </TD>
+                                </TR>
+                                <TR>
+                                    <TD>
+                                        <P><A HREF="http://www.gametools.org/videos/lodstrips.avi"><IMG ID="Picture22" HEIGHT=100 WIDTH=100 SRC="../assets/images/lodstrips.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="lodstrips" TITLE="lodstrips"></A></P>
+                                    </TD>
+                                    <TD VALIGN=TOP>
+                                        <P><SPAN STYLE="font-size: 8pt;">GPU Friendly Smooth Level of Detail without the need for Restripification</SPAN></P>
+                                    </TD>
+                                </TR>
+                                <TR>
+                                    <TD>
+                                        <P><A HREF="http://www.gametools.org/videos/chc.avi"><IMG ID="Picture454" HEIGHT=97 WIDTH=100 SRC="../assets/images/chc.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="chc" TITLE="chc"></A></P>
+                                    </TD>
+                                    <TD VALIGN=TOP>
+                                        <P><SPAN STYLE="font-size: 8pt;">Ont-the-fly Visibility Culling, without the need for preprocessing. Uses Coherent Hierarchical Culling (CHC) algorithm to avoid the framerate drops of the simple Stop-and-wait approach (Viewfrustrum Culling on the left, CHC on the right)</SPAN></P>
+                                    </TD>
+                                </TR>
+                                <TR>
+                                    <TD>
                                         <P><A HREF="http://www.gametools.org/videos/Explosion.avi"><IMG ID="Bild21" HEIGHT=100 WIDTH=100 SRC="../assets/images/Explosion_1_v0.gif" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="Watch DivX video" TITLE="Watch DivX video"></A></P>
                                     </TD>
                                     <TD VALIGN=TOP>
                                         <P><SPAN STYLE="font-size: 8pt;">Fire in the Hole !</SPAN></P>
-                                    </TD>
-                                </TR>
-                                <TR>
-                                    <TD>
-                                        <P>&nbsp;</P>
-                                    </TD>
-                                    <TD>
-                                        <P>&nbsp;</P>
-                                    </TD>
-                                </TR>
-                                <TR>
-                                    <TD COLSPAN=2 STYLE="background-color: rgb(166,179,224);">
-                                        <P STYLE="text-align: center;"><B>June 2005</B></P>
                                     </TD>
                                 </TR>
Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Styles/GameTools1-v19a/preview.xml
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Styles/GameTools1-v19a/preview.xml	(revision 740)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Styles/GameTools1-v19a/preview.xml	(revision 1065)
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<?xml-stylesheet type="text/xsl" href="template\siteStyle.xsl"?>
+<?xml-stylesheet type="text/xsl" href="template\siteStylePreview.xsl"?>
 <SiteStyle name="Glasgow - Aqua &amp; Orange" version="4"><Banners><Banner id="2" type="Image" name="Banner 1" alignment="576" orientation="0" justification="1" hoffset="5" voffset="0" hAlign="center" vAlign="-2"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg2.gif"/><Font css="font-family:Zero Threes; font-size:28; font-weight:700; font-style:normal; color:#000000; " pitchandfamily="0"/></Banner><Banner id="19" type="Text" name="Banner 2" alignment="576" orientation="0" justification="1" hoffset="5" voffset="0" hAlign="center" vAlign="11"><Font css="font-family:Zero Threes; font-size:28; font-weight:700; font-style:normal; color:#000000; background-color:#ffffff; width:600px; height:50px; text-align:center; " pitchandfamily="34"/></Banner><Banner id="21" type="Image" name="Banner 3" alignment="576" orientation="0" justification="1" hoffset="5" voffset="0" hAlign="center" vAlign="4"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg3.gif"/><Font css="font-family:Zero Threes; font-size:16; font-weight:400; font-style:normal; color:#ffffff; " pitchandfamily="34"/></Banner><Banner id="23" type="Image" name="Banner 4" alignment="576" orientation="0" justification="1" hoffset="5" voffset="0" hAlign="center" vAlign="6"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg4.gif"/><Font css="font-family:Zero Threes; font-size:11; font-weight:400; font-style:normal; color:#ffffff; " pitchandfamily="34"/></Banner><Banner id="25" type="Image" name="Banner 5" alignment="576" orientation="0" justification="1" hoffset="5" voffset="0" hAlign="center" vAlign="2"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg5.gif"/><Font css="font-family:Zero Threes; font-size:20; font-weight:400; font-style:normal; color:#ffffff; " pitchandfamily="34"/></Banner></Banners><Navbar><NavbarState name="Primary" id="3" flags="0" type="Image"><Border size="0"/><Space size="0"/><Button><ButtonState id="4" type="Image" name="Regular" alignment="4640" orientation="0" justification="1" hoffset="11" voffset="0" hAlign="left" vAlign="6"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg6.jpg"/><Font css="font-family:Zero Threes; font-size:11; font-weight:400; font-style:normal; color:#000000; " pitchandfamily="0"/></ButtonState><ButtonState id="5" type="Image" name="Rollover" alignment="4640" orientation="0" justification="1" hoffset="11" voffset="0" hAlign="left" vAlign="6"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg7.jpg"/><Font css="font-family:Zero Threes; font-size:11; font-weight:700; font-style:normal; color:#000000; " pitchandfamily="0"/></ButtonState><ButtonState id="6" type="Image" name="Highlighted" alignment="4640" orientation="0" justification="1" hoffset="11" voffset="0" hAlign="left" vAlign="6"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg8.jpg"/><Font css="font-family:Zero Threes; font-size:11; font-weight:400; font-style:normal; color:#ffffff; " pitchandfamily="0"/></ButtonState><ButtonState id="7" type="Image" name="HighlightedRollover" alignment="4640" orientation="0" justification="1" hoffset="11" voffset="0" hAlign="left" vAlign="6"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg9.jpg"/><Font css="font-family:Zero Threes; font-size:11; font-weight:700; font-style:normal; color:#ffffff; " pitchandfamily="0"/></ButtonState></Button></NavbarState><NavbarState name="Secondary" id="8" flags="0" type="Image"><Border size="0"/><Space size="0"/><Button><ButtonState id="9" type="Image" name="Regular" alignment="4640" orientation="0" justification="1" hoffset="14" voffset="0" hAlign="left" vAlign="8"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg10.gif"/><Font css="font-family:Trebuchet MS; font-size:8; font-weight:400; font-style:normal; color:#330066; " pitchandfamily="0"/></ButtonState><ButtonState id="10" type="Image" name="Rollover" alignment="4640" orientation="0" justification="1" hoffset="14" voffset="0" hAlign="left" vAlign="8"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg11.gif"/><Font css="font-family:Trebuchet MS; font-size:8; font-weight:700; font-style:normal; color:#330066; " pitchandfamily="0"/></ButtonState><ButtonState id="11" type="Image" name="Highlighted" alignment="4640" orientation="0" justification="1" hoffset="14" voffset="0" hAlign="left" vAlign="8"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg12.gif"/><Font css="font-family:Trebuchet MS; font-size:8; font-weight:700; font-style:normal; color:#330066; " pitchandfamily="0"/></ButtonState><ButtonState id="12" type="Image" name="HighlightedRollover" alignment="4640" orientation="0" justification="1" hoffset="14" voffset="0" hAlign="left" vAlign="8"><Image path="C:/DOCUME~1/ADMINI~1/LOCALS~1/Temp/nofimg13.gif"/><Font css="font-family:Trebuchet MS; font-size:8; font-weight:700; font-style:normal; color:#330066; " pitchandfamily="0"/></ButtonState></Button></NavbarState></Navbar><Line path="Images\line.gif" id="13"/><Bullet path="Images\dataicon.gif" id="14"/><Author name="Website Pros, Inc." id="15"/><TableStyles><TableStyle name="Table Style 1" id="17"><RepeatRegion><top>0</top><bottom>3</bottom><left>0</left><right>3</right></RepeatRegion><TableLayout name="" id="26"><row><cell transparent="1"><Font color="#000000">Text</Font></cell><cell transparent="1"><Font color="#000000">Text</Font></cell><cell transparent="1"><Font color="#000000">Text</Font></cell></row><row><cell transparent="1"><Font color="#000000">Text</Font></cell><cell transparent="1"><Font color="#000000">Text</Font></cell><cell transparent="1"><Font color="#000000">Text</Font></cell></row><row><cell transparent="1"><Font color="#000000">Text</Font></cell><cell transparent="1"><Font color="#000000">Text</Font></cell><cell transparent="1"><Font color="#000000">Text</Font></cell></row></TableLayout></TableStyle><TableStyle name="Table Style 2" id="28"><RepeatRegion><top>1</top><bottom>3</bottom><left>1</left><right>1</right></RepeatRegion><TableLayout name="" id="29"><row><cell bgcolor="#CCCCCC"><CssAttributes>BODY {  color:rgb(0,0,0); background-color:rgb(204,204,204); }</CssAttributes><Font color="#000000">Text</Font></cell></row><row><cell transparent="1"><Font color="#000000">Text</Font></cell></row><row><cell transparent="1"><Font color="#000000">Text</Font></cell></row></TableLayout></TableStyle></TableStyles></SiteStyle>
Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Styles/GameTools1-v19a/display.css
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Styles/GameTools1-v19a/display.css	(revision 740)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/Styles/GameTools1-v19a/display.css	(revision 1065)
@@ -1,6 +1,5 @@
 /* CSS definition file containing sitestyle stylesheets */
 BODY { font-family: Arial,Helvetica,Geneva,Sans-serif; font-size: 9pt; background-color: rgb(255,255,255); background-image: none;}
- .background { background-color: rgb(255,255,255); background-image: none; }
-A:active { color: rgb(255,0,0);}
+ A:active { color: rgb(255,0,0);}
  A:active { color: rgb(255,0,0);}
  A:active { color: rgb(255,0,0);}